#ifndef __CONNECTIONMGR_H__
#define __CONNECTIONMGR_H__

typedef struct Connection Connection;

#include "shellinaboxd.h"


void       initConnections(void);
Connection *addConnection(int fd,ServerData *serverData);
Connection *findConnection(int fd,ServerData **serverData);
void       markConnectionForDeletion(int fd);
int        deleteMarkedConnections(void (*)(int,Connection *,ServerData *));
Connection *firstConnection(int *fd,ServerData **serverData);
Connection *nextConnection(Connection *,int *fd,ServerData **serverData);
void       setConnectionTimeOut(Connection *connection,int timeOut);
int        isTimedOut(Connection *connection);
void       enablePollEvents(Connection *connection,int events);
void       disablePollEvents(Connection *connection,int events);
int        pollConnections(void);
int        getConnectionEvents(Connection *connection);

#endif

/*
 * Local variables:
 * mode: c
 * c-basic-offset: 4
 * indent-tabs-mode: nil
 * End:
 */
