#ifndef __FIFOMGR_H__
#define __FIFOMGR_H__

#include <stddef.h>


typedef struct FIFO FIFO;


FIFO *createNewFifo(size_t maxSize,void *data,void (*notifyAvailable)(void *),
                    void (*notifyEmpty)(void *),void (*notifyHasSpace)(void *),
                    void (*notifyFull)(void *),void (*flushAndClose)(void *));
void dupFifo(FIFO *fifo);
void destroyFifo(FIFO *fifo);
void fifoFlushAndClose(FIFO *fifo);
char *fifoCreateChunk(size_t len);
void fifoAppendChunk(FIFO *fifo,char *chunk,size_t len);
char *fifoGetFirstChunk(FIFO *fifo,size_t *len);
char *fifoGetNextChunk(const char *chunk,size_t *len);
void fifoDequeueChunk(FIFO *fifo,size_t len);
int  fifoStrCmp(FIFO *fifo,char *s);
int  fifoWriteV(int fd,FIFO *fifo);

#endif

/*
 * Local variables:
 * mode: c
 * c-basic-offset: 4
 * indent-tabs-mode: nil
 * End:
 */
