#include <fcntl.h>
#include <stdlib.h>
#include <sys/poll.h>
#include <sys/socket.h>
#include <syslog.h>
#include <unistd.h>

#include "cgicomm.h"
#include "server.h"
#include "shellinaboxd.h"


Connection *serverCreate(int fd)
{
    extern Fnc serverVTable[];
    ServerData *serverData;
    Connection *connection;

    serverData         = malloc(sizeof(ServerData));
    serverData->vTable = serverVTable;
    connection         = addConnection(fd,serverData);
    enablePollEvents(connection,POLLIN);
    return(connection);
}


static void serverPollIn(int pty,Connection *connection,void *serverData)
{
    char               fromBuf[128];
    struct sockaddr    *from   = (struct sockaddr *)fromBuf;
    socklen_t          fromLen = sizeof(fromBuf);

    // The CGI sent a new request on our UNIX domain socket
    int fd = accept(pty,from,&fromLen);
    if (fd >= 0) {
        fcntl(fd,F_SETFL,(long)(O_NONBLOCK|O_RDWR));
        cgiCommCreate(fd); }
    return;
}


static void serverPollHup(int pty,Connection *connection,void *serverData)
{
    syslog(LOG_DAEMON|LOG_ERR,"Unexpected error on server socket");
    exit(1);
}


Fnc serverVTable[VTABSIZE] = {
    (Fnc)serverPollIn,NULL,(Fnc)serverPollHup,NULL,NULL,NULL,NULL };

/*
 * Local variables:
 * mode: c
 * c-basic-offset: 4
 * indent-tabs-mode: nil
 * End:
 */
