#ifndef __SESSION_H__
#define __SESSION_H__

#include <utmpx.h>

#include "connectionmgr.h"
#include "fifo.h"
#include "shellinaboxd.h"


typedef struct Session {
#ifdef USELOGIN
    char         ptyName[PTYNAMELEN];
    struct utmpx utmpx;
#endif
    int          pid;
    int          inputSequenceNumber;
    int          outputSequenceNumber;
    FIFO         *pendingPoll;
    FIFO         *inputFifo;
    FIFO         *outputFifo;
} Session;


Connection *sessionCreate(int pid,int pty,char *ptyName,int *sequenceNumber,
                          struct utmpx *utmpx);

#endif

/*
 * Local variables:
 * mode: c
 * c-basic-offset: 4
 * indent-tabs-mode: nil
 * End:
 */
